﻿<%@ Page Language="C#" AutoEventWireup="true"  CodeFile="Default.aspx.cs" Inherits="_Default" %>
<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>ListBox Filter Starter Project</title>
    <style type="text/css">
        div.notes
        {
            color: Red;
            font-family: "Segoe UI", Arial;
            margin-bottom: 20px;
        }
        .RadListBox span.rlbText em
        { 
            background-color: #E5E5E5;
            font-weight: bold;
            font-style: normal;
        }
    </style>
</head>
<body>
    <form id="form1" runat="server">
    <telerik:RadCodeBlock runat="server" ID="RadCodeBlock1">
        <script type="text/javascript">
            //<![CDATA[
            var listbox;
            var filterTextBox;

            function pageLoad()
            {
                listbox = $find("<%= RadListBox1.ClientID %>");
                filterTextBox = document.getElementById("<%= TextBox1.ClientID %>");
                // set on anything but that 
                listbox._getGroupElement().focus();
            }

            function OnClientDroppedHandler(sender, eventArgs)
            {
                // clear emphasis from matching characters
                eventArgs.get_sourceItem().set_text(clearTextEmphasis(eventArgs.get_sourceItem().get_text()));
            }
            
            function filterList()
            {
                clearListEmphasis();
                createMatchingList();
            }

            // clear emphasis from matching characters for entire list
            function clearListEmphasis()
            {
                var re = new RegExp("</{0,1}em>", "gi");
                var items = listbox.get_items();
                var itemText;

                items.forEach
                (
                    function(item)
                    {
                        itemText = item.get_text();
                        item.set_text(clearTextEmphasis(itemText));
                    }
                )
            }

            // clear emphasis from matching characters for given text
            function clearTextEmphasis(text)
            {
                var re = new RegExp("</{0,1}em>", "gi");
                return text.replace(re, "");
            }
            
            // hide listboxitems without matching characters
            function createMatchingList()
            {
                var items = listbox.get_items();
                var filterText = filterTextBox.value;
                var re = new RegExp(filterText, "i");

                items.forEach
                (
                    function(item)
                    {
                        var itemText = item.get_text();

                        if (itemText.toLowerCase().indexOf(filterText.toLowerCase()) != -1)
                        {
                            item.set_text(itemText.replace(re, "<em>" + itemText.match(re) + "</em>"));
                            item.set_visible(true);
                        }
                        else
                        {
                            item.set_visible(false);
                        }
                    }
                )
            }

            //]]>
        </script>
    </telerik:RadCodeBlock>
    <telerik:RadScriptManager ID="RadScriptManager1"
        runat="server">
    </telerik:RadScriptManager>
    <div class="notes">
        See the "*Notes" section in the posting.
    </div>
    <div>
        <asp:TextBox ID="TextBox1"
            runat="server"
            Width="165px"
            onkeyup="filterList();" />
    </div>
    <br />
    <div>
        <telerik:RadListBox ID="RadListBox1"
            runat="server"
            Width="200px"
            Height="200px"
            AllowTransfer="true"
            TransferToID="RadListBox2"
            EnableDragAndDrop="true"
            OnClientDropped="OnClientDroppedHandler">
            <Items>
                <telerik:RadListBoxItem
                    Text="Kansas"
                    Value="KS" />
                <telerik:RadListBoxItem
                    Text="Texas"
                    Value="TX" />
                <telerik:RadListBoxItem
                    Text="Missouri"
                    Value="MO" />
                <telerik:RadListBoxItem
                    Text="Oklahoma"
                    Value="OK" />
                <telerik:RadListBoxItem
                    Text="Arizona"
                    Value="AZ" />
                <telerik:RadListBoxItem
                    Text="South Dakota"
                    Value="SD" />
                <telerik:RadListBoxItem
                    Text="Colorado"
                    Value="CO" />
                <telerik:RadListBoxItem
                    Text="New Mexico"
                    Value="NM" />
                <telerik:RadListBoxItem
                    Text="Iowa"
                    Value="IA" />
                <telerik:RadListBoxItem
                    Text="Nebraska"
                    Value="NE" />
                <telerik:RadListBoxItem
                    Text="Illinois"
                    Value="IL" />
                <telerik:RadListBoxItem
                    Text="Kentucky"
                    Value="KY" />
            </Items>
        </telerik:RadListBox>
        <telerik:RadListBox ID="RadListBox2"
            runat="server"
            Width="200px"
            Height="200px"
            EnableDragAndDrop="false">
        </telerik:RadListBox>
    </div>
    <telerik:RadInputManager ID="RadInputManager1" runat="server">
        <telerik:TextBoxSetting
            BehaviorID="TextBoxBehavior1"
            EmptyMessage="search states...">
            <TargetControls>
                <telerik:TargetInput ControlID="TextBox1" />
            </TargetControls>
        </telerik:TextBoxSetting>
    </telerik:RadInputManager>
    </form>
</body>
</html>
